<html>
<head>
<title>Ogre::ManualResourceLoader Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1ManualResourceLoader.html">ManualResourceLoader</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::ManualResourceLoader Class Reference<div class="ingroups"><a class="el" href="group__Resources.html">Resources</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::ManualResourceLoader" -->
<p>Interface describing a manual resource loader.  
 <a href="classOgre_1_1ManualResourceLoader.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreResource_8h_source.html">OgreResource.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::ManualResourceLoader:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1ManualResourceLoader__inherit__graph.gif" border="0" usemap="#Ogre_1_1ManualResourceLoader_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1ManualResourceLoader_inherit__map" id="Ogre_1_1ManualResourceLoader_inherit__map">
<area shape="rect" id="node3" href="classOgre_1_1Font.html" title="Class representing a font in the system." alt="" coords="5,83,88,112"/><area shape="rect" id="node5" href="classOgre_1_1MeshManager.html" title="Handles the management of mesh resources." alt="" coords="112,83,251,112"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1ManualResourceLoader-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ManualResourceLoader.html#a52b91457400f54642fd3c9e0182905f5">ManualResourceLoader</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ManualResourceLoader.html#a64c9f1f9f2817de97321412c59fabb5a">~ManualResourceLoader</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ManualResourceLoader.html#a7b4afd007622d165efbcc362e5566922">prepareResource</a> (<a class="el" href="classOgre_1_1Resource.html">Resource</a> *resource)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called when a resource wishes to load.  <a href="#a7b4afd007622d165efbcc362e5566922"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ManualResourceLoader.html#ae04795ab21e4a46709beb6d521a75c53">loadResource</a> (<a class="el" href="classOgre_1_1Resource.html">Resource</a> *resource)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called when a resource wishes to prepare.  <a href="#ae04795ab21e4a46709beb6d521a75c53"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Interface describing a manual resource loader. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Resources are usually loaded from files; however in some cases you want to be able to set the data up manually instead. This provides some problems, such as how to reload a <a class="el" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a> if it becomes unloaded for some reason, either because of memory constraints, or because a device fails and some or all of the data is lost. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>This interface should be implemented by all classes which wish to provide manual data to a resource. They provide a pointer to themselves when defining the resource (via the appropriate <a class="el" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>), and will be called when the <a class="el" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a> tries to load. They should implement the loadResource method such that the <a class="el" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a> is in the end set up exactly as if it had loaded from a file, although the implementations will likely differ between subclasses of <a class="el" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>, which is why no generic algorithm can be stated here. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>The loader must remain valid for the entire life of the resource, so that if need be it can be called upon to re-load the resource at any time. </dd></dl>

<p>Definition at line <a class="el" href="OgreResource_8h_source.html#l00512">512</a> of file <a class="el" href="OgreResource_8h_source.html">OgreResource.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a52b91457400f54642fd3c9e0182905f5"></a><!-- doxytag: member="Ogre::ManualResourceLoader::ManualResourceLoader" ref="a52b91457400f54642fd3c9e0182905f5" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ManualResourceLoader.html#a52b91457400f54642fd3c9e0182905f5">Ogre::ManualResourceLoader::ManualResourceLoader</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreResource_8h_source.html#l00515">515</a> of file <a class="el" href="OgreResource_8h_source.html">OgreResource.h</a>.</p>

</div>
</div>
<a class="anchor" id="a64c9f1f9f2817de97321412c59fabb5a"></a><!-- doxytag: member="Ogre::ManualResourceLoader::~ManualResourceLoader" ref="a64c9f1f9f2817de97321412c59fabb5a" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1ManualResourceLoader.html#a64c9f1f9f2817de97321412c59fabb5a">Ogre::ManualResourceLoader::~ManualResourceLoader</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreResource_8h_source.html#l00516">516</a> of file <a class="el" href="OgreResource_8h_source.html">OgreResource.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="ae04795ab21e4a46709beb6d521a75c53"></a><!-- doxytag: member="Ogre::ManualResourceLoader::loadResource" ref="ae04795ab21e4a46709beb6d521a75c53" args="(Resource *resource)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1ManualResourceLoader.html#ae04795ab21e4a46709beb6d521a75c53">Ogre::ManualResourceLoader::loadResource</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Resource.html">Resource</a> *&#160;</td>
          <td class="paramname"><em>resource</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called when a resource wishes to prepare. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">resource</td><td>The resource which wishes to prepare </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classOgre_1_1MeshManager.html#ab9db84516cdc6a681c3c491b259c35cd">Ogre::MeshManager</a>, and <a class="el" href="classOgre_1_1Font.html#ad9fb35dcaf249ea1d86a3fe849422e2d">Ogre::Font</a>.</p>

</div>
</div>
<a class="anchor" id="a7b4afd007622d165efbcc362e5566922"></a><!-- doxytag: member="Ogre::ManualResourceLoader::prepareResource" ref="a7b4afd007622d165efbcc362e5566922" args="(Resource *resource)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1ManualResourceLoader.html#a7b4afd007622d165efbcc362e5566922">Ogre::ManualResourceLoader::prepareResource</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Resource.html">Resource</a> *&#160;</td>
          <td class="paramname"><em>resource</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called when a resource wishes to load. </p>
<p>Note that this could get called in a background thread even in just a semithreaded ogre (OGRE_THREAD_SUPPORT==2). Thus, you must not access the rendersystem from this callback. Do that stuff in loadResource. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">resource</td><td>The resource which wishes to load </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="OgreResource_8h_source.html#l00524">524</a> of file <a class="el" href="OgreResource_8h_source.html">OgreResource.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreResource_8h_source.html">OgreResource.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:04
</p>
</body>
</html>
